from enum import Enum


class DecisionsAttaquees(str, Enum):
    """Liste pour le filtre DECISION_ATTAQUEE"""

    COMMISSION_INDEMNISATION_VICTIMES_INFRACTIONS = (
        "COMMISSION_INDEMNISATION_VICTIMES_INFRACTIONS"
    )
    CONSEIL_PRUDHOMME = "CONSEIL_PRUDHOMME"
    COUR_APPEL = "COUR_APPEL"
    COUR_ASSISES = "COUR_ASSISES"
    COUR_CASSATION = "COUR_CASSATION"
    COUR_JUSTICE_REPUBLIQUE = "COUR_JUSTICE_REPUBLIQUE"
    COUR_NATIONAL_INCAPACITE_TARIFICATION = "COUR_NATIONAL_INCAPACITE_TARIFICATION"
    TRIBUNAL_AFFAIRES_SECURITE_SOCIALE = "TRIBUNAL_AFFAIRES_SECURITE_SOCIALE"
    TRIBUNAL_COMMERCE = "TRIBUNAL_COMMERCE"
    TRIBUNAL_CONTENTIEUX_INCAPACITE = "TRIBUNAL_CONTENTIEUX_INCAPACITE"
    TRIBUNAL_CORRECTIONNEL = "TRIBUNAL_CORRECTIONNEL"
    TRIBUNAL_FORCES_ARMEES = "TRIBUNAL_FORCES_ARMEES"
    TRIBUNAL_GRANDE_INSTANCE = "TRIBUNAL_GRANDE_INSTANCE"
    TRIBUNAL_INSTANCE = "TRIBUNAL_INSTANCE"
    TRIBUNAL_MARITIME_COMMERCIAL = "TRIBUNAL_MARITIME_COMMERCIAL"
    TRIBUNAL_PARITAIRE_BAUX_RURAUX = "TRIBUNAL_PARITAIRE_BAUX_RURAUX"
    TRIBUNAL_POLICE = "TRIBUNAL_POLICE"
    TRIBUNAL_PREMIERE_INSTANCE = "TRIBUNAL_PREMIERE_INSTANCE"
    TRIBUNAL_SUPERIEURS_APPEL = "TRIBUNAL_SUPERIEURS_APPEL"


class CoursAppel(str, Enum):
    """Liste pour le filtre APPEL_SIEGE_APPEL"""

    GRENOBLE = "GRENOBLE"
    TOULOUSE = "TOULOUSE"
    PAU = "PAU"
    AMIENS = "AMIENS"
    BASSE_TERRE = "BASSE-TERRE"
    ROUEN = "ROUEN"
    MONTPELLIER = "MONTPELLIER"
    NIMES = "NIMES"
    LYON = "LYON"
    COLMAR = "COLMAR"
    AIX_PROVENCE = "AIX-PROVENCE"
    AGEN = "AGEN"
    ST_DENIS_REUNION = "ST-DENIS-REUNION"
    BESANCON = "BESANCON"
    CAEN = "CAEN"
    NANCY = "NANCY"
    ANGERS = "ANGERS"
    BORDEAUX = "BORDEAUX"
    BASTIA = "BASTIA"
    ORLEANS = "ORLEANS"
    DIJON = "DIJON"
    CAYENNE = "CAYENNE"
    PARIS = "PARIS"
    CHAMBERY = "CHAMBERY"
    NOUMEA = "NOUMEA"
    VERSAILLES = "VERSAILLES"
    DOUAI = "DOUAI"
    RIOM = "RIOM"
    BOURGES = "BOURGES"
    PAPEETE = "PAPEETE"
    REIMS = "REIMS"
    POITIERS = "POITIERS"
    METZ = "METZ"
    LIMOGES = "LIMOGES"
    FORT_DE_FRANCE = "FORT-DE-FRANCE"
    RENNES = "RENNES"


class FormationsJudiciaires(str, Enum):
    """Formations judiciaires"""

    AVIS = "AVIS"
    ORDONNANCE_PREMIER_PRESIDENT = "ORDONNANCE_PREMIER_PRESIDENT"
    COMMISSION_REEXAMEN = "COMMISSION_REEXAMEN"
    COUR_REVISION = "COUR_REVISION"
    COMMISSION_REVISION = "COMMISSION_REVISION"
    COMMISSION_REPARATION_DETENTION = "COMMISSION_REPARATION_DETENTION"
    TRIBUNAL_CONFLIT = "TRIBUNAL_CONFLIT"
    CHAMBRE_CIVILE_1 = "CHAMBRE_CIVILE_1"
    CHAMBRE_CIVILE_3 = "CHAMBRE_CIVILE_3"
    CHAMBRE_CRIMINELLE = "CHAMBRE_CRIMINELLE"
    CHAMBRE_MIXTE = "CHAMBRE_MIXTE"
    CHAMBRE_COMMERCIALE = "CHAMBRE_COMMERCIALE"
    ASSEMBLEE_PLENIERE = "ASSEMBLEE_PLENIERE"
    CHAMBRES_REUNIES = "CHAMBRES_REUNIES"


class JuridictionJudiciaire(str, Enum):
    """Liste pour filtre juridiction judiciaire"""

    cour_de_cassation = "Cour de cassation"
    juridictions_appel = "Juridictions d'appel"
    juridictions_1er_degre = "Juridictions du premier degré"


class SortOptions(str, Enum):
    """Options de tri"""

    RELEVANCE = "PERTINENCE"
    DATE_DESC = "DATE_DESC"
    DATE_ASC = "DATE_ASC"


class PublicationStatus(str, Enum):
    """Statut de publication"""

    PUBLISHED = "T"
    NOT_PUBLISHED = "F"


class FilterTypes(str, Enum):
    """Types de filtres disponibles"""

    PUBLICATION_BULLETIN = "CASSATION_TYPE_PUBLICATION_BULLETIN"
    FORMATION = "CASSATION_FORMATION"
    JURIDICTION_JUDICIAIRE = "JURIDICTION_JUDICIAIRE"
    COUR_APPEL = "APPEL_SIEGE_APPEL"
    DECISION_ATTAQUEE = "CASSATION_DECISION_ATTAQUEE"


class FacettesJURI(str, Enum):
    """
    Les filtres de JURI sont référencés dans le document "description-des-tris-et-filtres-de-l-pi.xlsx
    La liste ci-dessous n'en reprends qu'une partie. A ce stade, les filtres ne marchent pas
    pour le fond JURI'cassPubliBulletin'
    """

    CASSATION_TYPE_PUBLICATION_BULLETIN = "CASSATION_TYPE_PUBLICATION_BULLETIN"
    CASSATION_FORMATION = "CASSATION_FORMATION"
    JURIDICTION_JUDICIAIRE = "JURIDICTION_JUDICIAIRE"
    APPEL_SIEGE_APPEL = "APPEL_SIEGE_APPEL"
    CASSATION_NATURE_DECISION = "CASSATION_NATURE_DECISION"
    PDC_CHECKBOX_RESTREINDRE_ARRET = "PDC_CHECKBOX_RESTREINDRE_ARRET"
    PREMIER_DEGRE_TYPE_JURIDICTION = "PREMIER_DEGRE_TYPE_JURIDICTION"
    CASSATION_DECISION_ATTAQUEE = "CASSATION_DECISION_ATTAQUEE"
